#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ArenaFreeRankingCFG.h"
std::auto_ptr<Fish_ArenaFreeRankingCFG> Fish_ArenaFreeRankingCFG::msSingleton(nullptr);

int Fish_ArenaFreeRankingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArenaFreeRankingCFGData* Fish_ArenaFreeRankingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ArenaFreeRankingCFGData>& Fish_ArenaFreeRankingCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArenaFreeRankingCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ArenaFreeRankingCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArenaFreeRankingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		data.mRewardItem = element->IntAttribute("RewardItem");
		data.mRewardCount = element->IntAttribute("RewardCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ArenaFreeRankingCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArenaFreeRankingCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ArenaFreeRankingCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ArenaFreeRankingCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ArenaFreeRankingCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "StartRank", data.mStartRank);
		LuaCfgHelper::readInt(L, "EndRank", data.mEndRank);
		LuaCfgHelper::readInt(L, "RewardItem", data.mRewardItem);
		LuaCfgHelper::readInt(L, "RewardCount", data.mRewardCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ArenaFreeRankingCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArenaFreeRankingCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ArenaFreeRankingCFG* Fish_ArenaFreeRankingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArenaFreeRankingCFG());
	}
	return msSingleton.get();
}

void Fish_ArenaFreeRankingCFG::Release()
{
	msSingleton.reset(nullptr);
}
